if jit.os == "Linux" or jit.os == "OSX" or jit.os == "BSD" or jit.os == "POSIX" or jit.os == "Other" then
	local ffi = require("ffi")
	ffi.cdef [[
		struct timeval {
			long tv_sec;
			long tv_usec;
		};
		struct timezone {
			int tz_minuteswest;
			int tz_dsttime;
		};
		int gettimeofday(struct timeval *tv, struct timezone *tz);
	]]

	function os.clock()
		local Time = new("struct timeval")
		C.gettimeofday(Time, nil)
		return (Time.tv_sec + Time.tv_usec/1.0e6) - Start
	end

	local StartTimeval = ffi.new("struct timeval"); ffi.C.gettimeofday(StartTimeval, nil)
	local StartTime = StartTimeval.tv_sec + StartTimeval.tv_usec/1.0e6
	setfenv(os.clock, {Start = StartTime, new = ffi.new, C = ffi.C})
end
